// OrderGenerator.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

import swarm.collections.ListImpl;

/**
 * The OrderGenerator is used at present to simulate the market behavior.
 *
 * @author Pietro Terna
 */
public class OrderGenerator  extends SwarmObjectImpl{

    /** How many unit we have, used at present to define the max value
	used to generate the 'digits' composing our recipes */

    /** the max length of a recipe */
    public int maxStepNumber;

    /** used to record the number of generated orders*/
    public int orderCount;

    /** a specific order*/
    public Order anOrder;
    /** the list containig all the operating units*/
    public ListImpl unitList;
    /** the list containig all the orders*/
    public ListImpl orderList;
    /** the model (to which we apply mark up of the order revenue */
    VEFrameModelSwarm vEFrameModelSwarm;

    /** the integer vector containg a specific production recipe */
    public int[] orderRecipe;

    /**
     * the constructor for OrderGenerator
     */
    public OrderGenerator (Zone aZone, int msn, ListImpl ul, ListImpl ol, 
			   VEFrameModelSwarm mo) 
    {

	// Call the constructor for the OrderGenerator parent class.
	super(aZone);

	orderCount=0;
	maxStepNumber=msn;
	unitList=ul;
        orderList=ol;
	orderRecipe= new int[maxStepNumber];
        vEFrameModelSwarm = mo;
    }

    /** creating an order form, choosing its recipe length and content */
    public void createRandomOrderWithNSteps() {
	int i, randomStepNumber;
	boolean operatingUnitNotFound;
	Unit aUnit;

	orderCount++;

	randomStepNumber=Globals.env.uniformIntRand.getIntegerWithMin$withMax
		    (1, maxStepNumber);

	// putting 0 in the vector is not strictly necessary, but may be
	// useful for future software modifications
	for (i=1;i<=randomStepNumber;i++)orderRecipe[i-1]=0;

	for (i=1;i<=randomStepNumber;i++)
	    {
		orderRecipe[i-1]=
		    Globals.env.uniformIntRand.getIntegerWithMin$withMax
		    (1, unitList.getCount());
	    }

	anOrder = new Order(getZone(), orderCount,
			    Globals.env.getCurrentTime(),
			    randomStepNumber,orderRecipe, vEFrameModelSwarm);

        // add the active orders to the general order list (they will be
	// eliminated when dropped in a unit, being finished); this
	// list has been introduced for accounting purposes [may be it would
	// be better subtitute it with a get to the units to know their
	// waiting lists 
        orderList.addLast(anOrder);
	/**
	 * sending the order to the first production unit
	 * (we are acting as the Front End of the VE)
	 */
	operatingUnitNotFound=true;
	for (i=0;i<unitList.getCount() && operatingUnitNotFound;i++)
	    {
		aUnit=(Unit) unitList.atOffset(i);

		if (anOrder.getNextStep()==aUnit.getProductionPhase())
		    {
			operatingUnitNotFound=false;
			aUnit.setWaitingList(anOrder);
		    }
	    }
    }
}














